#include <stdio.h>

/*
	行列の指定方法は次のような通し番号で

	  1 2 3
	4 . . .
	5 . . .
	6 . . .
*/

#define N 2

#define TRUE 1
#define FALSE 0

int String[N*N];

int msize(void)
{
    return (N);
}

void PrintString(void)
{
	int i, j;

	printf("\n\t      ");
	for (i=1; i<=N; i++)
		printf("     [%2d]",i);
	printf("\n");

	for (i=0; i<N; i++) {
		printf("\t [%2d]", N+i+1);
		for (j=0; j<N; j++)
			printf("       %2d", String[i*N+j]);
		printf("\n");
	}
}


int CheckString(void)
{
	int i;

	/* 数字が昇順に並んでいることを確認する */
	for (i = 0; i < N * N - 1; i++)
		if (String[i] > String[i+1])
			return (FALSE);
	return (TRUE);
}


int Where(void)
{
	int i = 0;

	while (i < 1 || i > 2 * N) {
		printf("\n  Where rotate? ");
		scanf("%d",&i);
	}
	return i;
}


void Rotate(int n)
{
	void Swap();
	int i;

	/*
	 *   1 2 3 4 を
	 *   2 3 4 1 にするには
	 *   2 1 3 4 -> 2 3 1 4 -> 2 3 4 1
	 *   ^^^          ^^^          ^^^
	 *   という具合に、先頭から順にSwapすればよい
	 */

	if (n > N) /* row */ {
		for (i = 0; i < N - 1; i++)
			Swap(&String[(n - N - 1) * N + i], &String[(n - N - 1) * N + i + 1]);
	} else /* column */ {
		for (i = 0; i < N - 1; i++)
			Swap(&String[i * N + n - 1], &String[(i + 1) * N + n - 1]);
	}
}


void Swap(char *m, char *n)
{
	char tmp;

	tmp = *m;
	*m = *n;
	*n = tmp;
}
